<!DOCTYPE html>
<html>
    <head>

    </head>
    <body>
        <script>
            //global scope 
            document.write("GLOBAL SCOPE");
            var a="swetha";
            document.write("</br>"+a);
            {
                document.write("</br>block : "+a);
            }
            function f1()
            {
                document.write("</br>function : "+a);
            }
            var f2=()=>{document.write("</br>arrow : "+a);}
            var obj1={
                of1: function(){document.write("</br>object : "+a);}
            }
            f1();
            f2();
            obj1.of1();

            //BLOCK SCOPE
            //let and const keywords allows to declare variables in block
            document.write("</br></br>BLOCK SCOPE");
            let b="global_let";
            function blf1()
            {
                let b="blf1_let"
                var a="a inside blf1";
                document.write("</br>function-blf1 : "+a);
                document.write("</br>function-blf1 : "+b);
            }
            blf1();
            document.write("</br> let outside blf1 : "+a);

            var x1="var";
            let x2="let_var";
            {
                x2="let_vr1";
                x1="var1"
            }
            document.write("</br> var outside block : "+x1);
            document.write("</br> let outside block : "+x2);
            
            var x3="var";
            let x4="let_var";
            {
                let x4="let_vr4";
                var x3="var3"
            }
            document.write("</br> var outside block : "+x3);
            document.write("</br> let outside block : "+x4);
        
            //arrays
            document.write("</br></br>ARRAYS");
            a=[1,"swe",3.0];
            document.write("</br>initializing an array with different datatypes : "+a);//array can take elements of different datatypes
            //length of an array
            document.write("</br>length of an array : "+a.length);
            //for each
            document.write("</br></br>forEach");
            var fe1=[1,2,3];
            document.write("</br>Array with all intezers "+fe1+"</br>");
            fe1.forEach(twice);
            function twice(item)
            {
                document.write(item*2+" ");
            }
            document.write("</br>array with strings : ");
            //for each with intezers and strings
            var fe2=[1,"sw",2,"et",3,"ha"];
            fe2.forEach(twice);  //it doesn't throw any error but when we perform mathematical operations on strings it will result NaN

            //array with empty values
            document.write("</br>array with empty values : ");
            fe3=[1,,,,,2,3];
            fe3.forEach(twice);//forEach method doesn't thow any error if array contains empty values it simply discard those empty values
            
            //array with null values
            document.write("</br>array with null values : ");
            fe4=[1,null,2,3];
            fe4.forEach(twice);//doesn't throw any error [1,0,4,6]
            document.write("</br>");
            //fe4.forEach(toStr);
            function toStr(item)
            {
                document.write(item.toString()+" ");//we cant convert null to string hence execution stops
            }

            //array with undefined values
            fe5=[1,undefined,2,3];
            document.write("</br>array with undefined value : </br>");
            fe5.forEach(twice);
            document.write("</br>");
            //fe5.forEach(toStr); execution stops at undefined

            //array with objects
            fe6=[{name:"swetha",age:21},{name:"chandana",age:21},{name:"pavani",age:21}];
            document.write("</br>");
            fe6.forEach(name);

            function name(item)
            {
                document.write(item.name+" ");//accessing an array of object elements
            }

            //arrays using map method
            document.write("</br></br>MAP METHOD");
            ar1=[1,2,3];
            document.write("</br>");
            var ar2=ar1.map(double);
            document.write(ar2);
            function double(item)
            {
                return item*2;
            }

            //array with null values
            ar3=[1,2,null,3,null];
            document.write("</br>"+ar3.map(double));//map method accepts null values

            ar4=[1,undefined,3,4];
            document.write("</br>"+ar4.map(double));//map method accepts undefined values

            ar5=[1,,3,4];
            document.write("</br>"+ar5.map(double));//map method accepts empty values but doesnt perform any action on empty element
            document.write("</br>");
            //join method
            document.write(ar1.join("@")+"</br>");
            document.write(ar3.join("@")+"</br>");//1@2@@3@ 
            document.write(ar4.join("@")+"</br>");//1@@3@4
            document.write(ar5.join("@")+"</br>");//1@@3@4

            //filter method
            document.write("</br>FILTER METHOD</br>");
            marks=[30,20,41,60,70];
            document.write(marks.filter(gt50));
            function gt50(item)
            {
                return item>=50;
            }

            //reduce method
            document.write("</br></br>REDUCE METHOD</br>");
            document.write(marks.reduce(total));//initial value of a is 0
            document.write("</br>");
            document.write(marks.reduce(total,30));//here a value is 30
            document.write("</br>");
            document.write(marks.reduce(total,-200));//here a value is -200
            function total(a,c)
            {
                return a+c;
            }

            //pushing elements to an array
            //pushing adds elements at the end of an array
            document.write("</br></br>PUSH</br>");
            ar6=[];
            ar6.push(1);
            document.write(ar6+"</br>");
            ar6.push("swetha");
            document.write(ar6+"</br>");
            document.write(ar6.push(null)+"</br>");//returns 3 : length of an array
            document.write(ar6+"</br>");
            ar6.push(2,"techigai");//we can also push multiple values
            document.write(ar6+"</br>");

            //unshift
            //unshift adds elements at the start of an array
            document.write("</br></br>UNSHIFT</br>");
            document.write(ar6.unshift("Laptop")+"</br>");//return length of an array
            document.write(ar6+"</br>");
            ar6.unshift("pavani","chandana");//multiple values are allowed
            document.write(ar6);

            //poping an element from an array
            //pop deletes elements from ending of an array and returns deleted element
            document.write("</br></br>POP</br>");
            document.write(ar6.pop()+"</br>");
            document.write(ar6+"</br>");

            //shift method deletes elements from starting index of an array
            //this method also returns the deleted element
            document.write("</br></br>SHIFT</br>");
            document.write(ar6.shift()+"</br>");
            document.write(ar6+"</br>");

            //reverse() : reverse the element of an array - array order will also changes
            document.write("</br></br>REVERSE</br>");
            document.write(ar6.reverse()+"</br>");
            document.write(ar6+"</br>");

            //slice method
            document.write("</br></br>SHIFT</br>");
            ar7=[1,2,3,4,5,6];
            document.write(ar7.slice(1,4)+"</br>");
            document.write(ar7.slice(1,-2)+"</br>");//arrays have negative indexes in javascript - here -2 represents index-4
            document.write(ar7.slice(-5,-2)+"</br>");

            //splice method
            //used to insert certain number of elements starting from certain position and also delete elements
            document.write("</br></br>SPLICE</br>");
            ar8=["swetha","Chandana","Pavani"];
            ar8.splice(1,0,"Sravani","Sruthi");//from index 1 delete 0 elements and insert sruthi and sravani
            document.write(ar8+"</br>");
            ar8.splice(1,2); //starting from index 1 delete 2 elements
            document.write(ar8+"</br>");

        </script>
    </body>
</html>